<?php
/* External Track Config
---------------------------------------------------------------*/
// ** MySQL settings ** //
$slimtrack_ext = array();
$slimtrack_ext['DB_NAME'] = 'databasename';    // The name of the database
$slimtrack_ext['DB_USER'] = 'username';     // Your MySQL username
$slimtrack_ext['DB_PASSWORD'] = 'password'; // ...and password
$slimtrack_ext['DB_HOST'] = 'localhost';    // 99% chance you won't need to change this value
if(!defined('DB_CHARSET')) define('DB_CHARSET', 'utf8');
if(!defined('DB_COLLATE')) define('DB_COLLATE', '');

// You can have multiple installations in one database if you give each a unique prefix
$slimtrack_ext['table_prefix']  = 'wp_';   // Only numbers, letters, and underscores please!

/* BEGIN wp-settings.php 
---------------------------------------------------------------*/
// Turn register globals off
function wp_unregister_GLOBALS() {
	if ( !ini_get('register_globals') )
		return;

	if ( isset($_REQUEST['GLOBALS']) )
		die('GLOBALS overwrite attempt detected');

	// Variables that shouldn't be unset
	$noUnset = array('GLOBALS', '_GET', '_POST', '_COOKIE', '_REQUEST', '_SERVER', '_ENV', '_FILES', 'table_prefix');

	$input = array_merge($_GET, $_POST, $_COOKIE, $_SERVER, $_ENV, $_FILES, isset($_SESSION) && is_array($_SESSION) ? $_SESSION : array());
	foreach ( $input as $k => $v ) 
		if ( !in_array($k, $noUnset) && isset($GLOBALS[$k]) ) {
			$GLOBALS[$k] = NULL;
			unset($GLOBALS[$k]);
		}
}

wp_unregister_GLOBALS(); 

if ( ! isset($blog_id) )
	$blog_id = 1;

// Fix for IIS, which doesn't set REQUEST_URI
if ( empty( $_SERVER['REQUEST_URI'] ) ) {
	$_SERVER['REQUEST_URI'] = $_SERVER['SCRIPT_NAME']; // Does this work under CGI?

	// Append the query string if it exists and isn't null
	if (isset($_SERVER['QUERY_STRING']) && !empty($_SERVER['QUERY_STRING'])) {
		$_SERVER['REQUEST_URI'] .= '?' . $_SERVER['QUERY_STRING'];
	}
}

// Fix for PHP as CGI hosts that set SCRIPT_FILENAME to something ending in php.cgi for all requests
if ( isset($_SERVER['SCRIPT_FILENAME']) && ( strpos($_SERVER['SCRIPT_FILENAME'], 'php.cgi') == strlen($_SERVER['SCRIPT_FILENAME']) - 7 ) )
	$_SERVER['SCRIPT_FILENAME'] = $_SERVER['PATH_TRANSLATED'];

// Fix for Dreamhost and other PHP as CGI hosts
if (strpos($_SERVER['SCRIPT_NAME'], 'php.cgi') !== false)
	unset($_SERVER['PATH_INFO']);

// Fix empty PHP_SELF
$PHP_SELF = $_SERVER['PHP_SELF'];
if ( empty($PHP_SELF) )
	$_SERVER['PHP_SELF'] = $PHP_SELF = preg_replace("/(\?.*)?$/",'',$_SERVER["REQUEST_URI"]);

/* External PHP program tracking
---------------------------------------------------------------*/
define('SLIMSTATPATH',  dirname( dirname( __FILE__ ) ) . '/');
define('SLIMSTAT_EXTRACK', true);

function sstrack_external() {

	global $slimtrack_ext;

	$WP_ROOT_PATH = preg_replace('|wp-content.*$|','', __FILE__);
	// Ignore wordpress mu
	require($WP_ROOT_PATH.'wp-includes/version.php');
	if(strpos($wp_version, 'wordpress-mu') !== false)
		return;// external tracking does not support wpmu by now.

	/* START wp-db.php 
	------------------------------------*/
	if(!class_exists('wpdb')) :
	// prevent WP default wpdb instance
	$wpdb = '';
	require_once($WP_ROOT_PATH.'wp-includes/wp-db.php');

	$wpdb = new wpdb($slimtrack_ext['DB_USER'], $slimtrack_ext['DB_PASSWORD'], $slimtrack_ext['DB_NAME'], $slimtrack_ext['DB_HOST']);
	endif;

	$wpdb->prefix = $slimtrack_ext['table_prefix'];

	$wpdb->options = $slimtrack_ext['table_prefix'] . 'options';
	$GLOBALS['wpdb'] =& $wpdb;
	/* END wp-db.php
	------------------------------------*/

	/* START functions.php 
	------------------------------------*/
	if(!function_exists('get_option')) :
	function get_option($setting) {
		global $wpdb;
		$row = $wpdb->get_row("SELECT option_value FROM $wpdb->options WHERE option_name = '$setting' LIMIT 1");
		if( is_object( $row) ) { // Has to be get_row instead of get_var because of funkiness with 0, false, null values
			$value = $row->option_value;
		} else {
			return false;
		}
		// If home is not set use siteurl.
		if ( 'home' == $setting && '' == $value )
			return get_option('siteurl');
		if ( 'siteurl' == $setting || 'home' == $setting || 'category_base' == $setting )
			$value = preg_replace('|/+$|', '', $value);
		return maybe_unserialize($value);
	}
	endif;
	if(!function_exists('is_serialized')) :
	function is_serialized($data) {
		// if it isn't a string, it isn't serialized
		if ( !is_string($data) )
			return false;
		$data = trim($data);
		if ( 'N;' == $data )
			return true;
		if ( !preg_match('/^([adObis]):/', $data, $badions) )
			return false;
		switch ( $badions[1] ) :
		case 'a' :
		case 'O' :
		case 's' :
			if ( preg_match("/^{$badions[1]}:[0-9]+:.*[;}]\$/s", $data) )
				return true;
			break;
		case 'b' :
		case 'i' :
		case 'd' :
			if ( preg_match("/^{$badions[1]}:[0-9.E-]+;\$/", $data) )
				return true;
			break;
		endswitch;
		return false;
	}
	endif;
	if(!function_exists('maybe_unserialize')) :
	function maybe_unserialize($original) {
		if ( is_serialized($original) ) // don't attempt to unserialize data that wasn't serialized going in
			if ( false !== $gm = @ unserialize($original) )
				return $gm;
		return $original;
	}
	endif;
	if(!function_exists('add_magic_quotes')):
	function add_magic_quotes($array) {
		global $wpdb;

		foreach ($array as $k => $v) {
			if ( is_array($v) ) {
				$array[$k] = add_magic_quotes($v);
			} else {
				$array[$k] = $wpdb->escape($v);
			}
		}
		return $array;
	}
	endif;
	/* END functions.php
	------------------------------------*/

	/* START formatting.php 
	------------------------------------*/
	if(!function_exists('trailingslashit')):
	function trailingslashit($string) {
			if ( '/' != substr($string, -1)) {
					$string .= '/';
			}
			return $string;
	}
	endif;
	if(!function_exists('addslashes_gpc')):
	function addslashes_gpc($gpc) {
		global $wpdb;
		if (get_magic_quotes_gpc()) {
			$gpc = stripslashes($gpc);
		}
		return $wpdb->escape($gpc);
	}
	endif;
	if(!function_exists('stripslashes_deep')):
	function stripslashes_deep($value) {
		 $value = is_array($value) ? array_map('stripslashes_deep', $value) : stripslashes($value);
		 return $value;
	}
	endif;
	if(!function_exists('seems_utf8')):
	function seems_utf8($Str) { # by bmorel at ssi dot fr
		for ($i=0; $i<strlen($Str); $i++) {
			if (ord($Str[$i]) < 0x80) continue; # 0bbbbbbb
			elseif ((ord($Str[$i]) & 0xE0) == 0xC0) $n=1; # 110bbbbb
			elseif ((ord($Str[$i]) & 0xF0) == 0xE0) $n=2; # 1110bbbb
			elseif ((ord($Str[$i]) & 0xF8) == 0xF0) $n=3; # 11110bbb
			elseif ((ord($Str[$i]) & 0xFC) == 0xF8) $n=4; # 111110bb
			elseif ((ord($Str[$i]) & 0xFE) == 0xFC) $n=5; # 1111110b
			else return false; # Does not match any model
			for ($j=0; $j<$n; $j++) { # n bytes matching 10bbbbbb follow ?
				if ((++$i == strlen($Str)) || ((ord($Str[$i]) & 0xC0) != 0x80))
				return false;
			}
		}
		return true;
	}
	endif;
	/* END formatting.php 
	------------------------------------*/

	/* START deprecated.php 
	------------------------------------*/
	if(!function_exists('get_settings')) :
	function get_settings($option) {
		return get_option($option);
	}
	endif;
	/* END deprecated.php 
	------------------------------------*/

	/* CONTINUE wp-settings.php 
	------------------------------------*/
	// If already slashed, strip.
	if ( get_magic_quotes_gpc() ) {
		$_GET    = stripslashes_deep($_GET   );
		$_POST   = stripslashes_deep($_POST  );
		$_COOKIE = stripslashes_deep($_COOKIE);
	}

	// Escape with wpdb.
	$_GET    = add_magic_quotes($_GET   );
	$_POST   = add_magic_quotes($_POST  );
	$_COOKIE = add_magic_quotes($_COOKIE);
	$_SERVER = add_magic_quotes($_SERVER);

	/* OTHERS 
	------------------------------------*/
	if(!function_exists('is_admin')):
	function is_admin() {// TO DO
		$admin_check = array(// RegEx
				// zenphoto
				'/zen/', '/admin\.php',
				// vanilla	
				'/settings\.php', '/people\.php', '/settings/', '/account/', '/people/',
				// mediawiki	
				'title=Special:Userlog', 'Special:Preferences', 'title=MediaWiki:[^\.]+\.css&', 'title=-&action=',
				// dokuwiki
				'(\?|&)do=login', '(\?|&)do=admin', '(\?|&)do=edit', '(\?|&)do=logout', '(\?|&)do=profile',
				// photostack
				'organize\.php',
				// phpbb
				'/profile.php', '/login.php', '/admin/'
			);
		foreach($admin_check as $admin){
			if(ereg($admin, $_SERVER['REQUEST_URI']))
				return true;
		}
		global $wgCookiePrefix, $board_config;
		if(isset($_COOKIE['zenphoto_auth'])) { // ZenPhoto
			return true;
		} elseif (isset($wgCookiePrefix) && isset( $_COOKIE[$wgCookiePrefix.'UserID'] )) { // mediawiki
			return true;
		} elseif (isset($board_config['cookie_name']) && isset($_COOKIE[$board_config['cookie_name'].'_data'])) { // PHPBB
			$phpbb_auth = unserialize(stripslashes($_COOKIE[$board_config['cookie_name'] . '_data']));
			if($phpbb_auth['userid'] > -1 )
				return true;
		} elseif (isset($_COOKIE['DokuWiki'])) { // DokuWiki
			return true;
		}
		return false;
	}
	endif;

	$slimtrack_ext['cookiehash'] = md5(get_option('siteurl')); // Remove in 1.4
	include( SLIMSTATPATH . "wp-slimstat-ex-config.php" );
	$GLOBALS['SlimCfg'] =& $SlimCfg;
	$GLOBALS['slimtrack_ext'] =& $slimtrack_ext;
	include( SLIMSTATPATH . "lib/track.php" );

	$SSTrack->slimtrack();
	// destruct all.
	mysql_close($GLOBALS['wpdb']->dbh);
	$GLOBALS['wpdb'] = $GLOBALS['SlimCfg'] = $GLOBALS['slimtrack_ext'] = $wpdb = $SlimCfg = $slimtrack_ext = $SSTrack = null;
	unset($GLOBALS['wpdb'], $GLOBALS['SlimCfg'], $GLOBALS['slimtrack_ext'], $wpdb, $SlimCfg, $slimtrack_ext, $SSTrack);

}// End of sstrack_external

register_shutdown_function('sstrack_external');

/* External PHP program tracking END
---------------------------------------------------------------*/
?>