<?php
if(!class_exists('SSAdmin'))
	require_once(SLIMSTATPATH . 'lib/ss-admin/_functions.php');

if(!isset($ssAdmin))
	$ssAdmin =& SSAdmin::get_instance();

class SSUpgrade {

	function SSUpgrade() {

	}

	function substep_form($done, $step, $substep, $_message, $_buttontext, $ver) {
		if(strlen($ver) == 1) $ver = $ver.'0';
		if($substep == 0) {
			$substep = 1;
			$message = sprintf($_message['first'], $ver{0}.'.'.substr($ver, 1));
			$buttontext = $_buttontext['first'];
		} elseif (!$done) {
			$message = sprintf($_message['fail'], $substep);
			$buttontext = $_buttontext['fail'];
		} else {
			$substep++;
			$message = sprintf($_message['ok'], $substep);
			$buttontext = $_buttontext['ok'];
		}
		$action = 'upgrade.php?step='.$step.'&amp;substep_'.$ver.'='.$substep;
		$class = ($substep%2) ? 'substep-alt':'substep';
?>
<div class="<?php echo $class;?>">
<h3><?php printf(__('Sub-Step %s', 'slimstat-admin'), $substep); ?></h3>
<form method="post" action="<?php echo $action; ?>" id="substep_form">
<ul><li><?php echo $message; ?></li></ul>
<p class="submit"><input type="submit" name="substep_submit" id="substep_submit" value="<?php echo $buttontext; ?>" /></p>
</form>
</div>
<script type="text/javascript">//<![CDATA[
function disable_substep_submit() {
	var substep_form = document.getElementById('substep_form');
	substep_form.onsubmit = function(){
		substep_form.substep_submit.disabled = true;
		substep_form.submit();
	};
}
var disableSubmitButton = disable_substep_submit();
//]]></script>
<?php
	}

	function remove_unuesed_indexkeys_before_16_1() {
		global $ssAdmin;
		$upgrade = $ssAdmin->maybe_remove_indexkey('dt_total', 'common');
		if(!$upgrade) return false;
		$upgrade = $ssAdmin->maybe_remove_indexkey('dt_total', 'feed');
		if(!$upgrade) return false;
		$upgrade = $ssAdmin->maybe_remove_indexkey('resource_total', 'common');
		return $upgrade; 
	}

	function remove_unuesed_indexkeys_before_16_2() {
		global $ssAdmin;
		$upgrade = $ssAdmin->maybe_remove_indexkey('resource_total', 'feed');
		if(!$upgrade) return false;
		$upgrade = $ssAdmin->maybe_remove_indexkey('ip_from_to_idx', 'country');
		if(!$upgrade) return false;
		$upgrade = $ssAdmin->maybe_remove_indexkey('ip_from_idx', 'country');// wp-slimstat 0.92
		return $upgrade;
	}

	function add_indexkey_to_stat_table($key) {
		global $ssAdmin;
		$upgrade = $ssAdmin->maybe_add_indexkey($key,'common');
		if(!$upgrade) return false;
		$upgrade = $ssAdmin->maybe_add_indexkey($key,'feed');
		return $upgrade;
	}

	function createResourceTable() {
		require_once(SLIMSTATPATH . 'lib/setup.php');
		return SSSetup::_createSlimTable('resource');
	}

	function insertLocalSearchResource() {
		global $SlimCfg, $wpdb;
		$query1 = "UPDATE $SlimCfg->table_stats SET rs_id = 1 WHERE resource LIKE '__localsearch__' ";
		$query2 = "UPDATE $SlimCfg->table_feed SET rs_id = 1 WHERE resource LIKE '__localsearch__' ";
		$query3 = "INSERT IGNORE INTO $SlimCfg->table_resource ( `id`, `rs_string`, `rs_title`, `rs_condition`) VALUES (1, '__localsearch__', '', '[search]')";
		if($wpdb->query($query1) === false)
			return false;
		if($wpdb->query($query2) === false)
			return false;
		if($wpdb->query($query3) === false)
			return false;
		return true;
	}

	function insertOldResources() {
		global $SlimCfg, $wpdb;
		$query1 = "INSERT IGNORE INTO $SlimCfg->table_resource (`rs_string`)
			SELECT resource FROM $SlimCfg->table_stats
			WHERE rs_id <> 1
			GROUP BY resource";
		$query2 = "INSERT IGNORE INTO $SlimCfg->table_resource (`rs_string`)
			SELECT resource FROM $SlimCfg->table_feed
			WHERE rs_id <> 1
			GROUP BY resource";
		if($wpdb->query($query1) === false)
			return false;
		if($wpdb->query($query2) === false)
			return false;
		return true;
	}

	function updateResourceData() {
		global $SlimCfg, $wpdb;
		$query1 = "UPDATE $SlimCfg->table_stats ts, $SlimCfg->table_resource tr SET ts.rs_id = tr.id
				WHERE ts.resource=tr.rs_string
				AND ts.rs_id = '0'
				AND ts.rs_id <> '1' ";
		$query2 = "UPDATE $SlimCfg->table_feed ts, $SlimCfg->table_resource tr SET ts.rs_id = tr.id
				WHERE ts.resource=tr.rs_string
				AND ts.rs_id = '0'
				AND ts.rs_id <> '1' ";
		if($wpdb->query($query1) === false)
			return false;
		if($wpdb->query($query2) === false)
			return false;
		return true;
	}

	function updatePostTitleData() {
		global $SlimCfg, $wpdb;
		$query = "SELECT rs_string FROM $SlimCfg->table_resource WHERE rs_title LIKE '' AND rs_condition LIKE '' ";
		$unknown = $wpdb->get_results($query);
		if($unknown) {
			require_once(SLIMSTATPATH . 'lib/functions.php');
			$SlimCfg->option['guesstitle'] = 1;
			foreach($unknown as $r) {
				$_title = SSFunction::_guessPostTitle($r->rs_string);
				if(mysql_error($wpdb->dbh))
					return false;
			}
		}
		return true;
	}

	function removeResource_1() {
		global $SlimCfg, $wpdb, $ssAdmin;
		$query1 = "ALTER TABLE $SlimCfg->table_stats DROP COLUMN resource";
		$column1 = $ssAdmin->maybe_add_column($SlimCfg->table_stats, 'resource', '', true);
		if($column1 && $wpdb->query($query1) === false)
			return false;
		return true;
	}

	function removeResource_2() {
		global $SlimCfg, $wpdb, $ssAdmin;
		$query2 = "ALTER TABLE $SlimCfg->table_feed DROP COLUMN resource";
		$column2 = $ssAdmin->maybe_add_column($SlimCfg->table_feed, 'resource', '', true);
		if($column2 && $wpdb->query($query2) === false)
			return false;
		return true;
	}

	function renameRS_ID($table='common') {
		global $SlimCfg, $wpdb, $ssAdmin;
		$_table = ('feed' == $table) ? $SlimCfg->table_feed : $SlimCfg->table_stats;
		$query = "ALTER TABLE $_table CHANGE rs_id resource INT(11) NOT NULL DEFAULT 0";
		$column = $ssAdmin->maybe_add_column($_table, 'rs_id', '', true);
		if($column && $wpdb->query($query) === false)
			return false;
		return true;
	}

	function fix_domain_referer($table='common') {
		global $wpdb, $SlimCfg;
		$_table = ($table == 'feed') ? $SlimCfg->table_feed : $SlimCfg->table_stats;
		$query = "SELECT * FROM $_table ts WHERE ts.domain = '' AND ts.referer <> '' ";
		if($rows = $wpdb->get_results($query)) {
			foreach ($rows as $r) {
				$r->referer = preg_replace('|^http://|i', '', $r->referer);
				if(false === $uris = @parse_url('http://'.$r->referer)) {
					$r->domain = '';
					$r->referer = '';
				} else {
					if(!isset($uris['host'])) {
						$r->domain = '';
						$r->referer = '';
					} else {
						$r->domain = $uris['host'];
					}
				}
				$query2 = "UPDATE $_table ts SET ts.domain = '{$r->domain}', ts.referer = '{$r->referer}' WHERE ts.id = {$r->id} LIMIT 1";
				if(false === $wpdb->query($query2)) {
					return false;
				}
			}
		}
		return true;
	}

	function delete_uncompatible_pins_before16() {
		global $SlimCfg, $wpdb;
		require_once(SLIMSTATPATH . 'lib/pins.php');
		SSPins::findPins();
		if(mysql_error($wpdb->dbh))
			return false;
		return true;
	}

	function upgrade_from_before_16($step, $message, $buttontext) {
		global $SlimCfg, $ssAdmin;
		set_time_limit(180);
		$substep = (!isset($_GET['substep_16'])) ? 0 : (int)$_GET['substep_16'];
		switch($substep) {
			case 0:
				$done = true;
			break;
			case 1:
				$done = SSUpgrade::remove_unuesed_indexkeys_before_16_1();
			break;
			case 2:
				$done = SSUpgrade::remove_unuesed_indexkeys_before_16_2();
			break;
			case 3:
				$done = SSUpgrade::createResourceTable();
			break;
			case 4:
				$query = "ALTER TABLE $SlimCfg->table_stats ADD `rs_id` INT(11) NOT NULL DEFAULT 0 AFTER `resource`";
				$done = $ssAdmin->maybe_add_column($SlimCfg->table_stats, 'rs_id', $query);
			break;
			case 5:
				$query = "ALTER TABLE $SlimCfg->table_feed ADD `rs_id` INT(11) NOT NULL DEFAULT 0 AFTER `resource`";
				$done = $ssAdmin->maybe_add_column($SlimCfg->table_feed, 'rs_id', $query);
			break;
			case 6:
				$done = SSUpgrade::insertLocalSearchResource();
			break;
			case 7:
				$done = SSUpgrade::insertOldResources();
			break;
			case 8:
				$done = SSUpgrade::updateResourceData();
			break;
			case 9:
				$done = SSUpgrade::updatePostTitleData();
			break;
			case 10:
				$done = SSUpgrade::removeResource_1();
			break;
			case 11:
				$done = SSUpgrade::removeResource_2();
			break;
			case 12:
				$done = SSUpgrade::renameRS_ID('common');
			break;
			case 13:
				$done = SSUpgrade::renameRS_ID('feed');
			break;
			case 14:
				$done = $ssAdmin->maybe_add_indexkey('resource', 'common');
			break;
			case 15:
				$done = $ssAdmin->maybe_add_indexkey('resource', 'feed');
			break;
			case 16:
				$done = SSUpgrade::add_indexkey_to_stat_table('dt');
			break;
			case 17:
				$done = SSUpgrade::add_indexkey_to_stat_table('remote_ip');
			break;
			case 18:
				$done = SSUpgrade::add_indexkey_to_stat_table('referer');
			break;
			case 19:
				$done = SSUpgrade::add_indexkey_to_stat_table('searchterms');
			break;
			case 20:
				$done = SSUpgrade::add_indexkey_to_stat_table('country');
			break;
			case 21:
				$done = $ssAdmin->maybe_add_indexkey('ip_to', 'country');
			break;
			case 22:
				$done = $ssAdmin->pack_indexkey('country', '1');
			break;
			case 23:
				$done = SSUpgrade::fix_domain_referer('common');
			break;
			case 24:
				$done = SSUpgrade::fix_domain_referer('feed');
			break;
			case 25:
				$done = $ssAdmin->OptimizeTables(array('common', 'feed', 'resource'));
			break;
			case 26:
				$done = SSUpgrade::delete_uncompatible_pins_before16();
			break;
			case 27:
				return true;
			break;
		}
		SSUpgrade::substep_form($done, $step, $substep, $message, $buttontext, '16');
		return array(1);
	}

	function update_deleted_hvu() {
		global $wpdb, $SlimCfg;
		$backups = $wpdb->get_results("SELECT * FROM $SlimCfg->table_dt WHERE type > 10");
		if(!$backups)
			return true;
		// if previously failed to update dt table, delete broken data.
		$delete = $wpdb->query("DELETE FROM $SlimCfg->table_dt WHERE type = 13");

		$common = $wpdb->get_results("SELECT * FROM $SlimCfg->table_dt 	WHERE type = 11");
		foreach($common as $c) {
			$query = "SELECT * FROM $SlimCfg->table_dt WHERE type=12 AND ";
			$query .= "dt_end < ".($c->dt_end + 3599)." AND dt_end > ".($c->dt_end - 3599)." LIMIT 1";
			$f = $wpdb->get_row($query);
			if(!$f) continue;
			$query = "INSERT INTO ".$SlimCfg->table_dt." ( dt_start, dt_end, hits, visits, uniques, type ) VALUES ( ";
			$query .= min($c->dt_start,$f->dt_start) .", ".max($c->dt_end,$f->dt_end).", ";
			$query .= ($c->hits + $f->hits).", ".($c->visits + $f->visits).", ".($c->uniques + $f->uniques).", 13 )";
			$insert = $wpdb->query($query);
		}
		return $insert;
	}

	function upgrade_from_before_15($step, $message, $buttontext) {
		global $SlimCfg, $ssAdmin;
		$substep = (!isset($_GET['substep_15'])) ? 0 : (int)$_GET['substep_15'];
		switch($substep) {
			case 0:
				// Update Options
				if(!empty($SlimCfg->option['ignore']) && empty($SlimCfg->exclude['ignore_ip'])) {
					$SlimCfg->exclude['ignore_ip'] = $SlimCfg->option['ignore'];
					$update = update_option('wp_slimstat_ex_exclude', $SlimCfg->exclude);
					if($update)
						unset($SlimCfg->option['ignore']);
				}
				$_unset = array('stats_type','blog_stats','blog_js','meta','sweet_tips','trackings');
				foreach ($_unset as $_us) {
					if(isset($SlimCfg->option[$_us])) 
						unset($SlimCfg->option[$_us]);
				}
				update_option('wp_slimstat_ex', $SlimCfg->option);
				$done = true;
			break;
			case 1:
				//Update Pin table
				$query = "ALTER TABLE `".$SlimCfg->table_pins."` ADD `type` int(1) NOT NULL default 0 AFTER `active`";
				$done = $ssAdmin->maybe_add_column($SlimCfg->table_pins, 'type', $query);
			break;
			case 2:
				//Update dt table
				$done = SSUpgrade::update_deleted_hvu();
			break;
			case 3:
				return true;
			break;
		}
		SSUpgrade::substep_form($done, $step, $substep, $message, $buttontext, '15');
		return array(1);
	}

	function do_upgrade($step=1) {
		global $SlimCfg;
		$current_version = get_option('wp_slimstat_ex_version');
		if(!$current_version) {
			$updated = wp_slimstat_ex::check_current_version();
			if($updated)
				return true;
			$current_version = get_option('wp_slimstat_ex_version');
		}
		if($current_version == $SlimCfg->version) {
			return true;
		}
		$upgrade = true;

		$message = array( 'first'=>__('Upgrade from before %s', 'slimstat-admin'), 'fail'=>__('Failed to operate this sub-step(%s)', 'slimstat-admin'), 'ok'=>'<p>Ok, done.</p>'.__('Now we will do the next sub-step(%s)') );

		$buttontext = array('first'=>__('Start This Sub-Step', 'slimstat-admin'), 'fail'=>__('Do Over Again', 'slimstat-admin'), 'ok'=>__('Do This Step', 'slimstat-admin') );

		if($current_version < '1.5') {
			$upgrade = SSUpgrade::upgrade_from_before_15($step, $message, $buttontext);
			if(!$upgrade) return false;
			if(!is_array($upgrade))
				update_option('wp_slimstat_ex_version', '1.5');
		}
		if($upgrade && !is_array($upgrade) && $current_version < '1.6') {
			$upgrade = SSUpgrade::upgrade_from_before_16($step, $message, $buttontext);
			if(!$upgrade) return false;
			if(!is_array($upgrade))
				update_option('wp_slimstat_ex_version', '1.6');
		}
		if($upgrade && !is_array($upgrade))
			update_option('wp_slimstat_ex_version', $SlimCfg->version);

		return $upgrade;
	}

}

?>