<?php
/*
Module Name : Stats On Blog
Module URI : http://082net.com/tag/wp-slimstat-ex/
Author : Cheon, Young-Min
Author URI : http://082net.com/
License : All Wp-SlimStat-Ex Pins are GPL

Description ::

	You can check displayable module list on your SlimStat-Admin page
*/

/* DO NOT EDIT BELOW LINES */
if (!defined('SLIMSTATPATH')) { header('Location:/'); }

class SSBlogStats extends SSPins {
	// About this Pin
	var $Pinfo = array(
		'title' => 'Stats on Blog',
		'author' => '082net',
		'url' => 'http://082net.com',
		'text' => 'Display current modules you want - maybe on page or post',
		'version' => '0.2',
		'type' => 1,
	);

	// About displayable modules of this Pin
	var $Moinfo = array();
	var $op;

	function SSBlogStats() {
		$this->op = $this->get_option('stats_on_blog');
		if($this->op['ajax_lib']) 
			add_action('wp_print_scripts', array(&$this, 'enqueue_scripts'));
		add_action('wp_head', array(&$this, 'wp_head'), 20);
		add_filter('the_content', array(&$this, '_filter'), 10);
	}

	function pin_compatible() {
		global $SlimCfg;
		if($SlimCfg->version < '1.6') {
			return array	('compatible' => false, 'message' => 'Stats On Blog is only compatible with SlimStat-Ex 1.6 and above.');
		} else {
			return array('compatible' => true);
		}
	}

	function pin_actions() {
		return array( 'options' => 1, 'extra_table' => 0 );
	}

	function pin_update_options() {
		if(!isset($_POST['stats_on_blog']) || !is_array($_POST['stats_on_blog']))
			return;
		$this->op['use_filter'] = (int)$_POST['stats_on_blog']['use_filter'];
		$this->op['ajax_lib'] = trim($_POST['stats_on_blog']['ajax_lib']);
		$this->update_option('stats_on_blog', $this->op);
	}

	function pin_options() {
?>
<table width="100%" cellspacing="2" cellpadding="5" class="editform"> 
<tr valign="top"> 
	<th width="20%" scope="row"><?php _e('Use Content Filter:', 'wp-slimstat-ex') ?></th> 
	<td><?php _e('Replace {SLIMSTAT|1,2,3...} on content with displayable modules.', 'wp-slimstat-ex'); ?><br />
	<?php _e('Displayable modules are available at SlimStat-Admin page.', 'wp-slimstat-ex'); ?><br />
	<?php _e('You can manually insert &lt;?php wpSSBlogStats(); ?&gt; on your template file', 'wp-slimstat-ex'); ?><br />
		<select name="stats_on_blog[use_filter]">
			<option value="0"<?php if(!$this->op['use_filter']) { ?> selected="selected"<?php } ?>>NO</option>
			<option value="1"<?php if($this->op['use_filter']) { ?> selected="selected"<?php } ?>>YES</option>
		</select></td>
</tr>
<?php if(function_exists('wp_print_scripts')) { ?>
<tr valign="top"> 
	<th width="20%" scope="row"><?php _e('AJAX Library:', 'wp-slimstat-ex') ?></th> 
	<td><?php _e('Select javascript library for AJAX features or NONE for no AJAX', 'wp-slimstat-ex'); ?><br />
	<?php /*_e('If you select MooTools, you must load mootools(include Effects, Ajax) manually or install WP-Scripts plugin.', 'wp-slimstat-ex'); */?><br />
		<select name="stats_on_blog[ajax_lib]">
			<option value="0"<?php if(!$this->op['ajax_lib']) { ?> selected="selected"<?php } ?>>NONE</option>
			<option value="prototype"<?php if($this->op['ajax_lib']=='prototype') { ?> selected="selected"<?php } ?>>Prototype</option>
		</select></td>
</tr>
<?php } ?>
</table>
<?php
	}

	function _replace($m) {
		$m = trim($m[2]);
		if(empty($m))
			$IDs = array(1,2,3);
		else 
			$IDs = explode(',', str_replace(array('|', ' '), '', $m));
		return $this->print_stats($IDs, false);
	}

	function _filter($content) {
		if(!$this->op['use_filter'])
			return $content;
		return preg_replace_callback('/(<p>)*\s*{SLIMSTAT(.*?)}\s*\n*(<\/p>)*/', array(&$this, '_replace'), $content);
	}

	function wp_head() {
		global $SlimCfg;
		echo "\n".'<link rel="stylesheet" type="text/css" media="screen" href="'.$SlimCfg->pluginURL.'/pins/SSBlogStats/blogstats.css" />';
	}

	function enqueue_scripts() {
		global $SlimCfg;
		if(is_admin() || strstr($_SERVER['PHP_SELF'], 'wp-admin/') || strstr($_SERVER['REQUEST_URI'], 'wp-admin/'))
			return;
		$js_path = $SlimCfg->pluginURL.'/js/';
		switch($this->op['ajax_lib']) {
			case 'prototype':
			default:
			wp_register_script('moo.fx.base', $js_path.'moo.fx.base.js', array('prototype'), '2.0');
			wp_enqueue_script('ajax-slimstat-proto', $js_path.'ajax-slimstat-proto.js', array('prototype', 'moo.fx.base'), $SlimCfg->version);
			break;
		}
	}

	function print_stats($IDs = array(1,2,3), $echo = true) {
		global $SlimCfg, $wpdb;
		if(!is_array($IDs) || empty($IDs))
			return;
		if(!$this->op['ajax_lib'] || !function_exists('wp_print_scripts')) // only support AJAX with script-loader.php
			$SlimCfg->option['use_ajax'] = false;
		require_once(SLIMSTATPATH . 'lib/modules.php');
		$active_pins = $this->_getPins(1, 3);

		$wrapper = '<a id="ajax_request" href="'.$SlimCfg->ajaxReq.'"></a>';
		$wrapper .= '<a id="slm2" name="slm2"></a>'."\n";
		$wrapper .= '<div id="wp_slimstat">'."\n";
		$nav = '<p class="module_nav">'.__('Modules', 'wp-slimstat-ex').' : ';
		$output = '';

		foreach($IDs as $id) {
			if(empty($id))
				continue;
			$module = SSFunction::id2module($id);
			if($module) {
				$output .= call_user_func(array('SSModule', $module), '(1 = 1)');
				$nav .= '[ <a href="#module_'.$id.'">'.SSFunction::get_title($id).'</a> ] ';
			} elseif($id > 10000) {
				$pinid = floor($id/100) - 100;
				$mo = $id - (($pinid+100)*100) - 1;
				$pin = SSFunction::pin_mod_info($pinid);
				$pin_file = SLIMSTATPATH . 'pins/'. $pin['name'] . '/pin.php';

				if(!$pin || !file_exists($pin_file) || !$pin['active'] || $pin['type'] == 1 || !isset($pin['modules'][$mo])) {
					$output .= '<p>Wrong module ID '.$id.'</p>';
					continue;
				}
				if($pin['type'] == 0)// Display only Pins are not included yet.
					include_once($pin_file);

				$nav .= '[ <a href="#module_'.$id.'">'.$pin["modules"][$mo]["title"].'</a> ] ';
				eval('$temp_pin = new $pin["name"]();');
				$output .= call_user_func(array(&$temp_pin, $pin["modules"][$mo]["name"]), '(1 = 1)');
	/*			eval('$'.$pin["name"].' =& new $pin["name"]();'."\n");
				eval('$output .= $'.$pin["name"].'->'.$pin["modules"][$mo]["name"].'(\'(1 = 1)\');'."\n");*/
			}
		}
		$nav .= '<span id="slimloading"> ( Loading... ) </span>';
		$nav .= '</p>';
		$wrapper .= $nav.$output.'</div>';
		if($echo) 
			echo $wrapper;
		else 
			return $wrapper;
	}

}//end of class

/* Print Stats on Blog
------------------------------------------------------------------------*/
$wpSSBlogStats = new SSBlogStats();

function wpSSBlogStats($IDs = array(1,2,3), $echo = true) {
	global $wpSSBlogStats;
	return $wpSSBlogStats->print_stats($IDs, $echo);
}
?>