<?php

class SlimCfg {
	var $version = '1.606'; // Current SlimStat-Ex version
	var $external_iptc = 'internal'; // set this 'external' to use external ip-to-country database
	var $uaOption = false; // Personal use... please forget about this ;)
	var $last_db_update_version = '1.6';
	var $tbPrefix, $table_stats, $table_countries, $table_feed, $table_resource, $table_dt, $table_pins, $current_table;
	var $option, $exclude, $pluginURL, $ajaxReq, $get, $basedir, $web_path, $dt, $indexkey;
	var $is_wpmu;
	var $version_check_url = 'http://082net.com/update-check.php?check_plugin=wp-slimstat-ex';
	var $plugin_home = 'http://082net.com/tag/wp-slimstat-ex/';
	var $bot_array = array();

	function SlimCfg() {
		$this->_init();
	}

	function _init() {
		global $table_prefix;
		$this->is_wpmu = $this->is_wpmu();
		if (defined('SLIMSTAT_EXTRACK')) { // if external tracking
			global $slimtrack_ext;
			$table_prefix = $slimtrack_ext['table_prefix'];
		}
		// We use a bunch of tables to store data
		global $wpmuBaseTablePrefix;
		// Table names
		if($this->is_wpmu && isset($wpmuBaseTablePrefix))
			$this->table_countries = $wpmuBaseTablePrefix . "slim_countries";
		else 
			$this->table_countries = $table_prefix . "slim_countries";	// ip-to-country
		$this->tbPrefix = $table_prefix . "slimex_";
		$this->table_stats = $table_prefix . "slimex_stats";	// common stats
		$this->table_feed = $table_prefix . "slimex_feed";	 // feed stats
		$this->table_dt = $table_prefix . "slimex_dt";	 // compressed hit, vists, uniques
		$this->table_pins = $table_prefix . "slimex_pins";	// Pin information
		$this->table_resource = $table_prefix . "slimex_resource"; // resource table

		$this->basedir = dirname($this->_basename(__FILE__));	 // plugin folder name
		$this->pluginURL =  get_option('siteurl')."/wp-content/plugins/".$this->basedir;	 // Plugin URL(path)
		$this->ajaxReq = $this->pluginURL."/lib/r";	// Ajax request URL
		$this->web_path = $this->_getWebPath();	// wordpress intall folder related to site root
		$this->get = $this->parse_GET(); // panel, filters, encoded filters
		$this->current_table = $this->select_table(); // Current table to select
		$this->dt = array($this->_mktime(time()), $this->_mktime(time(), true)); // Blog midnight and server midnight
		$this->option = get_option('wp_slimstat_ex');	// SlimStat options
		$this->exclude = get_option('wp_slimstat_ex_exclude');	// Exclusion options
		$this->indexkey = array('common'=>$this->_getIndexKeys('common', true), 'feed'=>$this->_getIndexKeys('feed', true));
//		if( $this->exclude['ignore_bots'] ) {
			$this->bot_array['bots'] = array(12,43,45,46,47,48,49,50,51,52,53,107,108,109,110,111,121,135,136,159);
			$this->bot_array['feeds'] = array(13,14,15,20,44,54,55,56,57,61,91,95,96,97,98,99,100,130,131,132,133,134,137,138,139,140,141,142,143,144,146,147,148,149,150,151,152,154,156,157,1998);
			$this->bot_array['validators'] = array(16,17,18,93,123,124,125,126,127,128,129,1999);
			$this->bot_array['tools'] = array(19,22,40,41,72,73,77,80,85,58,59,60,145,155);
//		}
	}

	function _getIndexKeys($table = 'common', $deep = false) {
		global $wpdb;
		$_table = $this->string2table($table);
		$current_keys = array();
		$pre_len = array();
		$cur_len = array();
		$key_array = array('dt_total', 'resource_total', 'resource', 'searchterms', 'domain', 'referer', 'platform', 'browser', 'language', 'visit', 'country', 'remote_ip', 'dt', 'ip_to', 'ip_from_to_idx', 'ip_from_idx');
		if($myIndexStructure = $wpdb->get_results("SHOW INDEX FROM $_table", ARRAY_A)){
			foreach ( $myIndexStructure as $index_details ) {
				$key = $index_details['Key_name'];
				$col = $index_details['Column_name'];
				$len = $index_details['Cardinality'];
				$len = isset($pre_len[$key]) ? max($pre_len[$key], $len) : $len;
				$pre_len[$key] = $len;
				if(in_array($key, $key_array)) {
					if($deep) {
						$current_keys[$key]['column'][] = $col;
						$current_keys[$key]['length'] = $len;
					} else
						$current_keys[] = $key;
				}
			}
			return $current_keys;
		}
		return array();
	}

	function use_indexkey($mokey, $table='') {
		$table = ($table == '') ? $this->current_table : $table;
		$keys = ($table == $this->table_stats) ? $this->indexkey['common'] : $this->indexkey['feed'];
		$pkeys = array();
		if(isset($keys['remote_ip'])) $pkeys[] = 'remote_ip';
		if(isset($keys['resource'])) $pkeys[] = 'resource';
		if(isset($keys['referer'])) $pkeys[] = 'referer';
		if(isset($keys['domain'])) $pkeys[] = 'domain';
		if(isset($this->get['fd']) && isset($keys['dt'])) {// dt index will automatically applied
			if($mokey != 'dt' && in_array($mokey, $pkeys))
				return " USE INDEX (dt,{$mokey}) ";
			return " USE INDEX (dt)";
		}
		if(!isset($this->get['ff']))// use default 
			return "";
		$use_key = "";
		if(!isset($keys[$mokey]))
			$mokey = "";
		switch($this->get['ff']) {
			case 0:
				if(isset($keys['domain']))// varchar(255) index keys...
					return " USE INDEX (domain) ";
			break;
			case 1:
				if(isset($keys['searchterms']))// varchar(255) index keys...
					return " USE INDEX (searchterms) ";
			break;
			case 2:
				if(isset($keys['resource']))// This is primary key
					return " USE INDEX (resource) ";
			break;
			case 3:
				if(isset($keys['remote_ip']))// This is primary key
					return " USE INDEX (remote_ip) ";
				$use_key = 'remote_ip';
			break;
			case 4:
				$use_key = 'browser';
			break;
			case 5:
				$use_key = 'platform';
			break;
			case 6:
				$use_key = 'country';
			break;
			case 6:
				$use_key = 'language';
			break;
			default:
			break;
		}
		if(!isset($keys[$use_key]))
			$use_key = $mokey;
		if('' == $use_key)
			return "";
		return " USE INDEX (".(($keys[$mokey]['length'] > $keys[$use_key]['length']) ? $mokey : $use_key).") ";
	}

	// key length desc
	function indexkey_sort($a, $b) {
		if ($a['length'] == $b['length'])
			return 0;
		return ($a['length'] > $b['length']) ? -1 : 1;
	}

	function _basename($file) {
		$file = preg_replace('|\\\\+|', '\\\\', $file);
		$file = preg_replace('/^.*wp-content[\\\\\/]plugins[\\\\\/]/', '', $file);
		$file = preg_replace('/[\\\\\/]/', '/', $file);
		return $file;
	}

	function _getWebPath($url="home") {
		$home_path = parse_url(get_option($url));
		if ( isset($home_path['path']) )
			$home_path = $home_path['path'];
		else
			$home_path = '';
		$home_path = trim($home_path, '/');
		return $home_path;
	}

	function my_esc( $str = '' ) {
		return addslashes( $str );// Disable rest for now, causing problems
		if( version_compare( phpversion(), '4.3.0' ) == '-1' )
			return mysql_escape_string( $str );
		else
			return mysql_real_escape_string( $str );
	}

	function select_table() {
		$neededTable = ( $this->get['pn'] == 2 ) ? $this->table_feed : $this->table_stats;
		return $neededTable;
	}

	function string2table($table) {
		switch($table) {
			case 'feed':
				$_table = $this->table_feed;
			break;
			case 'country':
				$_table = $this->table_countries;
			break;
			case 'dt':
				$_table = $this->table_dt;
			break;
			case 'pins':
				$_table = $this->table_pins;
			break;
			case 'resource':
				$_table = $this->table_resource;
			break;
			case 'common':
				$_table = $this->table_stats;
			break;
			default:
				$_table = $table;
			break;
		}
		return $_table;
	}

	function sstime($time, $back_to_server_time = false) {
		$offset = (int)$this->option['time_offset'] * 60 * 60;
		if ($offset !== 0) {
			$time = $back_to_server_time ? $time - $offset : $time + $offset;
		}
		return $time;
	}

	function _mktime($time, $back_to_server_time = false) {
		$dt = $this->sstime($time);
		$new_dt = mktime( 0, 0, 0, date( "n", $dt ), date( "d", $dt ), date( "Y", $dt ) );
		if($back_to_server_time)
			$new_dt = $this->sstime( $new_dt, true );
		return $new_dt;
	}

	function _date($date_format, $time) {
		return mysql2date($date_format, date('Y-m-d H:i:s', $time));
	}

	function parse_GET($filter_encode = true, $interval = true, $normal = true) {
		$get = array();
		$get['pn'] = (isset($_GET['panel']))?(int)$_GET['panel']:1;
		$f_interval = isset($_GET['fd']) ? trim(urldecode($_GET['fd'])) : null;
		if( $normal && isset($_GET['fi']) && isset($_GET['ff']) && isset($_GET['ft']) ) {
			$get['ff'] = (int)$_GET['ff'];
			$get['ft'] = (int)$_GET['ft'];
			$get['fi'] = urldecode($_GET['fi']);
		}
		if ( $interval && isset( $f_interval ) && strpos( $f_interval, "|" ) ) {
			$get['fd'] = array(0, 0);
			$intervals = explode( "|", $f_interval, 2 );
			$intervals[0] = (int)$intervals[0];
			$intervals[1] = (int)$intervals[1];
			if( max( $intervals ) > 0 && ($intervals[1] > $intervals[0]) ) {
				$get['fd'] = array( $intervals[0], $intervals[1] );
			}
		}
		$get['slim_table'] = isset($_GET['slim_table']) ? trim($_GET['slim_table']) : null;
		//re-encode filter values
		if($filter_encode) {
			$get['fi_encode'] = "";
			$get['fd_encode'] = "";
			if($normal && isset($get['fi'])) 
				$get['fi_encode'] = '&amp;ff='.$get['ff'].'&amp;ft='.$get['ft'].'&amp;fi='.urlencode($get['fi']);
			if ( $interval && isset($get['fd']) ) 
				$get['fd_encode'] = '&amp;fd='.$f_interval;
			if($get['slim_table'])
				$get['fi_encode'] .= '&amp;slim_table='.$get['slim_table'];
		}
		$get['offset'] = isset($_GET['offset']) ? (int)$_GET['offset'] : 0;
		$get['offset'] = ($get['offset'] < 0) ? 0 : $get['offset'];
		return $get;
	}

	function truncate($text, $len = 120) {
		if (function_exists('mb_strcut')) {
			$output = (strlen($text) >$len) ? mb_strcut($text, 0, $len, get_option('blog_charset')) . '...' : $text;
		} else {
			$output = (strlen($text) >$len) ? substr($text, 0, $len) . "..." : $text;
		}
		return $output;
	}

	function trimString($r, $length = 26) {
		$r = eregi_replace( "http://", "", $r );
		$r = eregi_replace( "^www.", "", $r );
		$r = $this->truncate($r, $length);
		return $r;
	}

	function is_wpmu() {
		global $wp_version;
		return strpos($wp_version, 'wordpress-mu') !== false;
	}
	
	// borrowed from K2 theme (http://getk2.com)
	function wp_version() {
		global $wp_version, $wporg_version;
		if(!$this->is_wpmu)
			return $wp_version;

		if(isset($wporg_version)) {
			preg_match("/\d\.\d/i", $wporg_version, $match);
			return $match[0];
		}
		// wpmu - increment version by 1.0 to match wp
		preg_match("/\d\.\d/i", $wp_version, $match);
		$match[0] = $match[0] + 1.0;
	}

	//borrowed from Extended Live Archives(http://www.sonsofskadi.net/extended-live-archive/)
	function version_check() {
		$remote == false;
/*		if( function_exists('wp_remote_fopen') && (ini_get('allow_url_fopen') ||  function_exists('curl_init')) ) {
			$remote = wp_remote_fopen($this->version_check_url);
		} else {*/
			if(!class_exists('Snoopy')) 
				require(ABSPATH . 'wp-includes/class-snoopy.php');
			$client = new Snoopy();
			$client->_fp_timeout = 4;
			if (@$client->fetch($this->version_check_url) !== false) {
				$remote = $client->results;
			}
//		}
		if(!$remote || strlen($remote) > 8 || 'error' == $remote) return -1;
		if ($remote > $this->version) return 1; else return 0;
	}

	function check_user($redirect = true) {
		auth_redirect();
		$location = get_option('siteurl'). '/wp-admin/options-general.php?page=wp-slimstat-ex-options';
		if(function_exists('current_user_can')) {
			$has_cap = current_user_can('manage_options');
		} else {
			global $user_level;
			get_currentuserinfo();
			$has_cap = $user_level >= 8;
		}
		if ( !$has_cap ) {
			if($redirect) {
				if(function_exists('wp_redirect'))
					wp_redirect($location);
				else 
					header('Location: '.$location.'');
				exit();
			} else 
				return false;
		}
		return true;
	}

	function &get_instance() {
		static $instance = array();
		if ( empty( $instance ) ) {
			$instance[] =& new SlimCfg();
		}
		return $instance[0];
	}
}

if(!isset($SlimCfg))
	$SlimCfg =& SlimCfg::get_instance();
?>