<?php

class wp_slimstat_ex_options {
	var $page, $wpssop, $url, $pinpage, $adminpage, $exclusionpage, $admin_url;

	function wp_slimstat_ex_options() {
		global $SlimCfg;
		$this->page = $_GET['page'];
		$this->wpssop = isset($_GET['wpssop']) ? $_GET['wpssop'] : false;
		$this->url = 'options-general.php?page=wp-slimstat-ex-options';
		$this->admin_url = get_option('siteurl') . '/wp-content/plugins/' . $SlimCfg->basedir . '/lib/ss-admin';
		$this->pinpage = $this->wpssop == 'pin';
		$this->adminpage = $this->wpssop == 'admin';
		$this->exclusionpage = $this->wpssop == 'exclusion';
	}

	function update_options() {
		global $SlimCfg;
		if(!$this->wpssop) {
			if ( !isset($_POST['ssex_op']) || !is_array($_POST['ssex_op']) )// Main Options
				return;
			$intvals = array( 'tracking', 'usepins', 'guesstitle', 'cachelimit', 'limitrows', 'dbmaxage', 'iptohost', 'whois', 'meta', 'time_offset', 'use_ajax', 'nice_titles' );
			foreach($_POST['ssex_op'] as $key=>$value) {
				$SlimCfg->option[$key] = (in_array($key, $intvals)) ? (int)$value : stripslashes(trim($value));
			}
			update_option('wp_slimstat_ex', $SlimCfg->option);
			echo '<div id="message" class="updated fade"><p>'.__('Wp-SlimStat-Ex options updated', 'wp-slimstat-ex').'</p></div>';
		} elseif ($this->pinpage)
			$this->manage_pins();
		elseif ($this->exclusionpage)
			$this->manage_exclusions();
		elseif ($this->adminpage)
			$this->manage_admin_options();
	}

	function manage_admin_options() {
		if ( isset($_POST['do_reimport']) ) {
			require(SLIMSTATPATH . 'lib/setup.php');
			$rebuild = SSSetup::rebuild_iptc_db();
			if($rebuild)
				echo '<div id="message" class="updated fade"><p>'.__('ip-to-country data imported successfully.', 'wp-slimstat-ex').'</p></div>';
			else 
				echo '<div id="message" class="updated fade"><p>'.__('Failed to import ip-to-country data.', 'wp-slimstat-ex').'</p></div>';
		}
	}

	function manage_exclusions() {
		global $SlimCfg;
		if ( isset($_POST['ig_op']) && is_array($_POST['ig_op']) ) {
			$checkboxes = array('ig_bots', 'ig_feeds', 'ig_validators', 'ig_tools');
			foreach($checkboxes as $box)
				$SlimCfg->exclude[$box] = isset($_POST['ig_op'][$box]);
			$intvals = array('ignore_bots');
			foreach($_POST['ig_op'] as $key=>$value) {
				if(!in_array($key, $checkboxes))
					$SlimCfg->exclude[$key] = (in_array($key, $intvals))?(int)$value:stripslashes(trim($value));
			}
			update_option('wp_slimstat_ex_exclude', $SlimCfg->exclude);
			echo '<div id="message" class="updated fade"><p>'.__('Wp-SlimStat-Ex options updated', 'wp-slimstat-ex').'</p></div>';
		}
	}

	function manage_pins() {
		global $SlimCfg, $wpdb;
		if ( isset($_GET["pinact"]) && $_GET["pinact"] != '' ) {
			$pin_id = (int)$_GET['pinid'];
			$pin_active = (int)$_GET['pinact'];

//			require_once(SLIMSTATPATH . 'lib/pins.php');
			$pin = SSPins::getPin($pin_id);
			if(!$pin) {
				echo '<div id="message" class="updated fade"><p>'.__('Invalid Pin ID.', 'wp-slimstat-ex').'</p></div>';
				return;
			}

			$pin_file = SLIMSTATPATH . 'pins/'.$pin->name.'/pin.php';
			if(!file_exists($pin_file)) {
				SSPins::delete_pin("`id` = $pin->id");
				echo '<div id="message" class="updated fade"><p>'.__('Pin file does not exists.', 'wp-slimstat-ex').'</p></div>';
				return;
			}

			if($pin_active) {
				if($pin->active) {
					echo '<div id="message" class="updated fade"><p>'.__('Pin already activated.', 'wp-slimstat-ex').'</p></div>';
					return;
				}

				$default_compatible = SSPins::pin_compatible();

				ob_start();
				@include_once($pin_file);
				if(!class_exists($pin->name)) {
					ob_end_clean();
					echo '<div id="message" class="updated fade"><p>'.$default_compatible['message'].'</p></div>';
					return;
				}

				eval('$temp_pin = new $pin->name();');
				if('sspins' != strtolower(get_parent_class($temp_pin))) {
					ob_end_clean();
					echo '<div id="message" class="updated fade"><p>'.$default_compatible['message'].'</p></div>';
					return;
				}

				$compatible = $temp_pin->pin_compatible();
				if(!$compatible['compatible']) {
					ob_end_clean();
					if(isset($compatible['message']) && !empty($compatible['message']))
						echo '<div id="message" class="updated fade"><p>'.$compatible['message'].'</p></div>';
					else 
						echo '<div id="message" class="updated fade"><p>'.$default_compatible['message'].'</p></div>';
					return;
				}

				$actions = $temp_pin->pin_actions();
				if( $actions['extra_table'] && isset($temp_pin->extra_table) && 
						is_array($temp_pin->extra_table) && !empty($temp_pin->extra_table)) {// dobule check if Pin really needs extra table
					$create_table = SSPins::maybe_create_extra_table($temp_pin->extra_table);
					if(!$create_table) {
						ob_end_clean();
						echo '<div id="message" class="updated fade"><p>'.__('Failed to activate Pin', 'wp-slimstat-ex').'</p></div>';
						return;
					}
				}
				$temp_pin->activate_action();
				ob_end_clean();
			} else {
				if(!$pin->active) {
					echo '<div id="message" class="updated fade"><p>'.__('Pin already deactivated.', 'wp-slimstat-ex').'</p></div>';
					return;
				}
				ob_start();
				@include_once($pin_file);
				if(class_exists($pin->name)) {
					eval('$temp_pin = new $pin->name();');
					if('sspins' == strtolower(get_parent_class($temp_pin)))
						$temp_pin->deactivate_action();
				}
				ob_end_clean();
			}
			$query = "UPDATE $SlimCfg->table_pins SET active = $pin_active WHERE id = $pin_id LIMIT 1";
			if($wpdb->query($query) !== false) {
				if($pin_active)
					$message = __('Pin activated', 'wp-slimstat-ex');
				else
					$message = __('Pin deactivated', 'wp-slimstat-ex');
			} else {
				if($pin_active)
					$message = __('Failed to activate Pin', 'wp-slimstat-ex');
				else
					$message = __('Failed to deactivate Pin', 'wp-slimstat-ex');
			}
			echo '<div id="message" class="updated fade"><p>'.$message.'</p></div>';
			return;
		}
	}

	function nav_bar() {
		global $SlimCfg;
?>
		<div id="wpssoptionselector" style="font-size:18px;">
<?php 
	echo '
	<span>'.($this->wpssop ? '<a href="'.$this->url.'" title="'.__('General Options').'">':'').__('General Options', 'wp-slimstat-ex').($this->wpssop ? '</a>':'').'</span> | ';
	if($SlimCfg->option['usepins']) {
	echo '
	<span>'.(!$this->pinpage ?'<a href="'.$this->url.'&amp;wpssop=pin" title="'.__('Pins', 'wp-slimstat-ex').'">':'').__('Pins', 'wp-slimstat-ex').(!$this->pinpage ? '</a>':'').'</span> | ';
	}
	echo '
	<span>'.(!$this->exclusionpage ?'<a href="'.$this->url.'&amp;wpssop=exclusion" title="'.__('Exclusions', 'wp-slimstat-ex').'">':'').__('Exclusions', 'wp-slimstat-ex').(!$this->exclusionpage ? '</a>':'').'</span> | ';
	echo '
	<span>'.(!$this->adminpage ?'<a href="'.$this->url.'&amp;wpssop=admin" title="'.__('SlimStat-Admin', 'wp-slimstat-ex').'">':'').__('SlimStat-Admin', 'wp-slimstat-ex').(!$this->adminpage ? '</a>':'').'</span>';
?>
		</div>
		<br />
<?php
	}

	function options_page() {
		global $SlimCfg;
		$this->update_options();
		if ($SlimCfg->option['update_check'] && ($remote = $SlimCfg->version_check()) == 1 ) {
			echo '<div id="message" class="updated fade"><p><a href="'.$SlimCfg->plugin_home.'">'.__('There is a plugin update available', 'wp-slimstat-ex').'</a></p></div>';
		}
?>
<div class="wrap">
  <h2><?php _e('Wp-SlimStat-Ex', 'wp-slimstat-ex') ?></h2>

	<?php $this->nav_bar(); ?>

<?php /********** Main Option Page ***********/
	if(!$this->wpssop) { ?>
	<form name="slimstat_option" method="post" action="<?php echo $this->url; ?>"> 
    <!-- <p class="submit" style="float:right;"><input type="submit" name="update_options" value="<?php _e('Update Options', 'wp-slimstat-ex') ?> &raquo;" /></p> -->

		<fieldset class="options">
<!-- General Options Start -->
		<legend><?php _e('General Options'); ?></legend>
			<table width="100%" cellspacing="2" cellpadding="5" class="editform" id="optiontable1"> 
      <tr valign="top">
        <th width="25%" scope="row"><?php _e('Enable Tracking?:', 'wp-slimstat-ex') ?></th> 
        <td><select name="ssex_op[tracking]">
          <option value="1"<?php if ($SlimCfg->option['tracking']) { ?> selected="selected"<?php } ?>>enable</option>
          <option value="0"<?php if (!$SlimCfg->option['tracking']) { ?> selected="selected"<?php } ?>>disable</option>
          </select><br />
<?php _e('&mdash; If you want to track blog visitors select &quot;enable&quot;', 'wp-slimstat-ex') ?></td> 
      </tr>
      <tr valign="top">
        <th width="25%" scope="row"><?php _e('Update Check:', 'wp-slimstat-ex') ?></th> 
        <td><select name="ssex_op[update_check]">
          <option value="1"<?php if ($SlimCfg->option['update_check']) { ?> selected="selected"<?php } ?>>true</option>
          <option value="0"<?php if (!$SlimCfg->option['update_check']) { ?> selected="selected"<?php } ?>>false</option>
          </select><br />
<?php _e('&mdash; Automatically check if plugin update is available', 'wp-slimstat-ex') ?></td> 
      </tr>
      <tr valign="top">
        <th width="25%" scope="row"><?php _e('Use Pins?:', 'wp-slimstat-ex') ?></th> 
        <td><select name="ssex_op[usepins]">
          <option value="1"<?php if ($SlimCfg->option['usepins']) { ?> selected="selected"<?php } ?>>true</option>
          <option value="0"<?php if (!$SlimCfg->option['usepins']) { ?> selected="selected"<?php } ?>>false</option>
          </select><br />
<?php _e('&mdash; If you want to use Pins select &quot;true&quot;', 'wp-slimstat-ex') ?></td> 
      </tr>
      <tr valign="top">
        <th width="25%" scope="row"><?php _e('Use AJAX?:', 'wp-slimstat-ex') ?></th> 
        <td><select name="ssex_op[use_ajax]">
          <option value="1"<?php if ($SlimCfg->option['use_ajax']) { ?> selected="selected"<?php } ?>>true</option>
          <option value="0"<?php if (!$SlimCfg->option['use_ajax']) { ?> selected="selected"<?php } ?>>false</option>
          </select><br />
<?php _e('&mdash; Use &quot;AJAX&quot; or not?. Setting it to false will disable some modules.', 'wp-slimstat-ex') ?></td> 
      </tr>
<?php if($SlimCfg->option['use_ajax']) { ?>
      <tr valign="top"> 
        <th width="25%" scope="row"><?php echo __('Ajax cache limit:', 'wp-slimstat-ex') ?></th> 
        <td><input name="ssex_op[cachelimit]" type="text" value="<?php echo $SlimCfg->option['cachelimit']; ?>" size="3" /> 
		  <?php echo __('minutes', 'wp-slimstat-ex'); ?><br />
<?php echo __('&mdash; Cache time of Ajax result page by minutes. (disable cache = 0)', 'wp-slimstat-ex') ?></td> 
      </tr>
<?php } ?>
      <tr valign="top"> 
        <th width="25%" scope="row"><?php _e('SQL limit rows:', 'wp-slimstat-ex') ?></th> 
        <td><input name="ssex_op[limitrows]" type="text" value="<?php echo $SlimCfg->option['limitrows']; ?>" size="3" /> 
		  <?php _e('rows', 'wp-slimstat-ex'); ?><br />
<?php _e('&mdash; Limit rows of each modules', 'wp-slimstat-ex') ?></td> 
      </tr>
      <tr valign="top">
        <th width="25%" scope="row"><?php _e('DB max-age:', 'wp-slimstat-ex') ?></th> 
        <td><input name="ssex_op[dbmaxage]" type="text" value="<?php echo $SlimCfg->option['dbmaxage']; ?>" size="3" /> 
		  <?php _e('days', 'wp-slimstat-ex'); ?><br />
<?php _e('&mdash; Set database max-age by days (disable reduce DB : 0)', 'wp-slimstat-ex') ?><br />
<?php _e('&mdash; You can reduce DB from ', 'wp-slimstat-ex') ?>"<a href="<?php echo $this->admin_url; ?>/admin.php">ss-admin</a>"<?php _e(' page', 'wp-slimstat-ex') ?></td> 
      </tr>
			</table>
<!-- General Options End -->
<!-- Display Options Start -->
		<legend><?php _e('Display Options'); ?></legend>
			<table width="100%" cellspacing="2" cellpadding="5" class="editform" id="optiontable2"> 
			<tr valign="top">
        <th width="25%" scope="row"><?php _e('Visit type:', 'wp-slimstat-ex') ?></th> 
        <td><select name="ssex_op[visit_type]">
          <option value="uniques"<?php if ($SlimCfg->option['visit_type'] == 'uniques') { ?> selected="selected"<?php } ?>>uniques</option>
          <option value="visits"<?php if ($SlimCfg->option['visit_type'] == 'visits') { ?> selected="selected"<?php } ?>>visits</option>
          </select><br />
<?php _e('&mdash; Select visit type. uniques: count unique ip, visits: 30-minute intervals', 'wp-slimstat-ex') ?></td> 
      </tr>
      <tr valign="top">
        <th width="25%" scope="row"><?php _e('Guess post title?:', 'wp-slimstat-ex') ?></th> 
        <td><select name="ssex_op[guesstitle]">
          <option value="1"<?php if ($SlimCfg->option['guesstitle']) { ?> selected="selected"<?php } ?>>true</option>
          <option value="0"<?php if (!$SlimCfg->option['guesstitle']) { ?> selected="selected"<?php } ?>>false</option>
          </select><br />
<?php _e('&mdash; Get post title from resource(page address)', 'wp-slimstat-ex') ?></td> 
      </tr>
      <tr valign="top">
        <th width="25%" scope="row"><?php _e('Get host name?:', 'wp-slimstat-ex') ?></th> 
        <td><select name="ssex_op[iptohost]">
          <option value="1"<?php if ($SlimCfg->option['iptohost']) { ?> selected="selected"<?php } ?>>true</option>
          <option value="0"<?php if (!$SlimCfg->option['iptohost']) { ?> selected="selected"<?php } ?>>false</option>
          </select><br />
<?php _e('&mdash; Get host name from remote address', 'wp-slimstat-ex') ?>(IP)</td> 
      </tr>
      <tr valign="top">
        <th width="25%" scope="row"><?php _e('Use Whois link?:', 'wp-slimstat-ex') ?></th> 
        <td><select name="ssex_op[whois]">
          <option value="1"<?php if ($SlimCfg->option['whois']) { ?> selected="selected"<?php } ?>>true</option>
          <option value="0"<?php if (!$SlimCfg->option['whois']) { ?> selected="selected"<?php } ?>>false</option>
          </select><br />
<?php _e('&mdash; Use &quot;Whois&quot; link on &quot;Visitors&quot; modules', 'wp-slimstat-ex') ?></td> 
      </tr>
			</table>
<!-- Display Options End -->
<!-- Extra Options Start -->
		<legend><?php _e('Extra Options'); ?></legend>
			<table width="100%" cellspacing="2" cellpadding="5" class="editform" id="optiontable3"> 
      <tr valign="top">
        <th width="25%" scope="row"><?php _e('Nice Titles:', 'wp-slimstat-ex') ?></th> 
        <td><select name="ssex_op[nice_titles]">
          <option value="1"<?php if ($SlimCfg->option['nice_titles']) { ?> selected="selected"<?php } ?>>true</option>
          <option value="0"<?php if (!$SlimCfg->option['nice_titles']) { ?> selected="selected"<?php } ?>>false</option>
          </select><br />
<?php _e('&mdash; Enable or disable &quot;Nice Titles&quot;. Powered by <a href="http://www.dustindiaz.com/sweet-titles-finalized">SweetTitles</a>', 'wp-slimstat-ex') ?></td> 
      </tr>
		<tr valign="top"> 
        <th width="25%" scope="row"><?php _e('Your server time is:', 'wp-slimstat-ex') ?></th> 
        <td><?php echo date('Y-m-d g:i:s a', time()); ?></td> 
      </tr>
      <tr valign="top"> 
        <th width="25%" scope="row"><?php _e('Time Offset:', 'wp-slimstat-ex') ?></th> 
        <td><input name="ssex_op[time_offset]" type="text" value="<?php echo $SlimCfg->option['time_offset']; ?>" size="3" /> 
		  <?php _e('hours', 'wp-slimstat-ex'); ?>
<?php _e('&mdash; Time offset from server time by hours.(NOT gmt offset)', 'wp-slimstat-ex') ?></td> 
      </tr>
      <tr valign="top"> 
        <th width="25%" scope="row"><?php _e('Your blog time is:', 'wp-slimstat-ex') ?></th> 
        <td><?php echo date('Y-m-d g:i:s a', (time() + ($SlimCfg->option['time_offset'] * 60 * 60))); ?></td> 
      </tr>
	</table>
<!-- Extra Options End -->
		</fieldset>
    <p class="submit">
    <input type="submit" name="update_options" value="<?php _e('Update Options', 'wp-slimstat-ex') ?> &raquo;" />
    </p>
  </form>
<?php 
	} /********** Pin Option Page ***********/
	elseif( $SlimCfg->option['usepins'] && $this->pinpage ) {
		$_optin_page = $this->option_pins();
	} /********** Exclusion Option Page ***********/
	elseif($this->exclusionpage) { 
		$_optin_page = $this->option_exclusions();
	} /********** Admin Option Page ***********/
	elseif($this->adminpage) {
		$_optin_page = $this->option_admin();
	}
?>
</div><!-- wrap -->
<?php 
	}

	function option_pins() {
		global $SlimCfg;
//		require_once(SLIMSTATPATH . 'lib/pins.php');
		SSPins::findPins();
		$pins = SSPins::_getPins(0,5,true);// get all pins
?>
	<fieldset class="options">
  <legend><?php _e('Pins', 'wp-slimstat-ex') ?></legend>
<?php 
		if ( empty($pins) ) {
			echo '<p>There is no Pins available</p>'; 
		} else { 
?>
	<table width="100%" cellpadding="3" cellspacing="3">
	<tr>
	  <th class="vers"><?php _e('ID', 'wp-slimstat-ex'); ?></th>
	  <th class="name"><?php _e('Name (version)', 'wp-slimstat-ex'); ?></th>
	  <th class="vers"><?php _e('Author', 'wp-slimstat-ex'); ?></th>
	  <th class="desc"><?php _e('Description', 'wp-slimstat-ex'); ?></th>
	  <th class="togl"><?php _e('Acitve', 'wp-slimstat-ex'); ?></th>
	</tr>
<?php 
			$alt = '';
			$get_page = $_GET['page'];
			foreach($pins as $pin) {
				$alt = ($alt == ' alternate')?'':' alternate';
				$class_tr = ($pin->active == 1)?'active':'waitingpin';
				$class_act = ($pin->active == 1)?'delete':'edit';
				$act_text = ($pin->active == 1)?__('Deactivate', 'wp-slimstat-ex'):__('Activate', 'wp-slimstat-ex');
?>
	<tr class="<?php echo $class_tr . $alt; ?>">
	  <td class="vers"><?php echo $pin->id; ?></td>
	  <td class="name"><?php echo $pin->title . " ( " . $pin->version . " )"; ?></td>
	  <td class="vers"><a href="<?php echo $pin->url; ?>" title="Author URL"><?php echo $pin->author; ?></a></td>
	  <td class="desc" width="50%"><?php echo $pin->text; ?></td>
	  <td class="togl"><a class="<?php echo $class_act; ?>" href="<?php echo $this->url; ?>&amp;wpssop=pin&amp;pinact=<?php echo (($pin->active == 1)?'0':'1'); ?>&amp;pinid=<?php echo $pin->id; ?>"><?php echo $act_text; ?></a></td>
	 </tr>
<?php 
			} /* foreach */
?>
	 </table>
	</fieldset>
<?php 
			$active_pins = SSPins::_getPins(1,5);// get all active pins
			if(empty($active_pins))
				return;
			$include_pins = SSPins::_incPins(0);// include all active pins - funtionable pins are already included.
			$i = 0;
			$_opt_pins = array();
			foreach($active_pins as $pin) {
				if(!class_exists($pin->name))
					continue;
				eval('$_pin{$i} = new $pin->name();');
				if('sspins' != strtolower(get_parent_class($_pin{$i})))
					continue;
				$_pin_opt = $_pin{$i}->pin_actions();
				if(!$_pin_opt['options'])
					continue;
				$_opt_pins[] = array($_pin{$i}, $pin);
				$i++;
			}
			if(empty($_opt_pins))
				return;
?>
	<hr />
	<?php SSPins::update_pin_options($_opt_pins); ?>
	<?php SSPins::pin_option_menu_bar($_opt_pins); ?>

<form name="slimstat_pin_options" id="slimstat_pin_options" method="post" action="<?php echo $this->url; ?>&amp;wpssop=pin#slimstat_pin_options">
<?php
			$first_option = true;
			foreach($_opt_pins as $pin) {
				$display = $first_option ? '' : ' style="display:none;"';
				$first_option = false;
?>
	<fieldset<?php echo $display; ?> class="options" id="pin_option_<?php echo $pin[1]->id; ?>">
	<legend><?php echo wp_specialchars($pin[1]->title, 1); ?> Options</legend>
	<?php $pin[0]->pin_options(); ?>
	</fieldset>
<?php
			}
?>
	<p class="submit">
		<input type="submit" name="slimstat_pin_options_submit" value="<?php _e('Update Options  &raquo;') ?>" />
	</p>
</form>
<?php
		} /* is there any pins? */
	}

	function option_exclusions() {
		global $SlimCfg;
?>
	<form name="slimstat_option_exclusion" method="post" action="<?php echo $this->url; ?>&amp;wpssop=exclusion"> 
		<fieldset class="options">
<!-- Exclusion Options Start -->
		<legend><?php _e('Exclusion Options'); ?></legend>
			<table width="100%" cellspacing="2" cellpadding="5" class="editform" id="optiontable4"> 
      <tr valign="top"> 
        <th width="25%" scope="row"><?php _e('Ignore IP-List:', 'wp-slimstat-ex') ?></th> 
        <td><?php _e('This setting define which remote ip will <em>always</em> not to be tracked.', 'wp-slimstat-ex'); ?><br />
		  <?php _e('Seperate multiple ip with semi-colon( ; )', 'wp-slimstat-ex'); ?><br /><br />
		  <textarea name="ig_op[ignore_ip]" cols="60" rows="4" style="width: 98%; font-size: 12px;"><?php echo wp_specialchars($SlimCfg->exclude['ignore_ip'],true); ?></textarea></td> 
      </tr>
			<tr valign="top">
       <th width="25%" scope="row"><?php _e('Ignore Bots?:', 'wp-slimstat-ex') ?></th> 
       <td><select name="ig_op[ignore_bots]">
         <option value="0"<?php if (!$SlimCfg->exclude['ignore_bots']) { ?> selected="selected"<?php } ?>><?php _e('No', 'wp-slimstat-ex') ?></option>
         <option value="1"<?php if ($SlimCfg->exclude['ignore_bots'] == 1) { ?> selected="selected"<?php } ?>><?php _e('Disable track', 'wp-slimstat-ex') ?></option>
         <!-- <option value="2"<?php// if ($SlimCfg->exclude['ignore_bots'] == 2) { ?> selected="selected"<?php //} ?>><?php _e('Disable display', 'wp-slimstat-ex') ?></option>
         <option value="3"<?php //if ($SlimCfg->exclude['ignore_bots'] == 3) { ?> selected="selected"<?php //} ?>><?php //_e('Track and display', 'wp-slimstat-ex') ?></option> -->
         </select> <br />
				<?php _e('&mdash; Ignore miscellaneous bots, crawlers and empty user-agent visitors.', 'wp-slimstat-ex') ?><br />
				<!-- <?php //_e('&mdash; Selecting option related to "display" may slow down your stats page.', 'wp-slimstat-ex') ?><br /> -->
				<?php	if($SlimCfg->exclude['ignore_bots']) _e('&mdash; See more settings below.', 'wp-slimstat-ex'); 
					else _e('&mdash; More options will shown while you enable this option.', 'wp-slimstat-ex'); ?>
				</td>
			</tr>
<?php if ($SlimCfg->exclude['ignore_bots']) { ?>
			<tr valign="top">
       <th width="25%" scope="row"><?php _e('More Exclusions:', 'wp-slimstat-ex') ?></th> 
       <td>
			 <label for="ig_bots"><?php _e('Ignore famous Bots(google,yahoo,msn...)', 'wp-slimstat-ex') ?> : </label>
			 <input id="ig_bots" type="checkbox" name="ig_op[ig_bots]" value="1"<?php checked(1, $SlimCfg->exclude['ig_bots']); ?> />
			 <br /><br />
			 <label for="ig_feeds"><?php _e('Ignore RPC Service(technorati,feedburner...) and RSS readers', 'wp-slimstat-ex') ?> :</label>
			 <input id="ig_feeds" type="checkbox" name="ig_op[ig_feeds]" value="1"<?php checked(1, $SlimCfg->exclude['ig_feeds']); ?> />
			 <br /><br />
			 <label for="ig_validators"><?php _e('Ignore validators(w3c,feedvalidator...)', 'wp-slimstat-ex') ?> : </label>
			 <input id="ig_validators" type="checkbox" name="ig_op[ig_validators]" value="1"<?php checked(1, $SlimCfg->exclude['ig_validators']); ?> />
			 <br /><br />
			 <label for="ig_tools"><?php _e('Ignore fetching tools (curl,snoopy...)', 'wp-slimstat-ex') ?> : </label>
			 <input id="ig_tools" type="checkbox" name="ig_op[ig_tools]" value="1"<?php checked(1, $SlimCfg->exclude['ig_tools']); ?> />
			 </td>
			</tr>
      <tr valign="top"> 
        <th width="25%" scope="row"><?php _e('Black User-Agent List:', 'wp-slimstat-ex') ?></th> 
        <td><?php _e('SlimStat will <em>always ignore</em> User-Agent below.', 'wp-slimstat-ex'); ?><br />
		  <?php _e('Seperate multiple pattern with new line.', 'wp-slimstat-ex'); ?><br />
			<p><?php _e('Some <a href="http://php.net/manual/reference.pcre.pattern.syntax.php" title="syntax help">syntaxes</a>(^, $, *) are available.', 'wp-slimstat-ex') ?> &mdash; <?php _e('"*" means non-whitespace characters (\\S*?)', 'wp-slimstat-ex'); ?></p>
		  <textarea name="ig_op[black_ua]" cols="60" rows="4" style="width: 98%; font-size: 12px;"><?php echo wp_specialchars($SlimCfg->exclude['black_ua'],true); ?></textarea></td> 
      </tr>
      <tr valign="top"> 
        <th width="25%" scope="row"><?php _e('White User-Agent List:', 'wp-slimstat-ex') ?></th> 
        <td><?php _e('SlimStat will <em>always track</em> User-Agent below. (will be applied before ignore list)', 'wp-slimstat-ex'); ?><br />
		  <?php _e('Seperate multiple pattern with new line.', 'wp-slimstat-ex'); ?><br /><br />
		  <textarea name="ig_op[white_ua]" cols="60" rows="4" style="width: 98%; font-size: 12px;"><?php echo wp_specialchars($SlimCfg->exclude['white_ua'],true); ?></textarea></td> 
      </tr>
<?php } ?>
	</table>
<!-- Exclusion Options End -->
		</fieldset>
    <p class="submit">
    <input type="submit" name="update_options" value="<?php _e('Update Options', 'wp-slimstat-ex') ?> &raquo;" />
    </p>
  </form>
<?php
	}

	function option_admin() {
		global $SlimCfg, $table_prefix;
?>
	<fieldset class="options">
  <legend><?php _e('SlimStat-Ex Admin Tools', 'wp-slimstat-ex') ?></legend>
  <ul>
  <li><?php echo __('Delete SlimStat data more than &quot;DB max-age(', 'wp-slimstat-ex') . (($SlimCfg->option['dbmaxage']==0)?'disabled':$SlimCfg->option['dbmaxage']) .__(')&quot; days old', 'wp-slimstat-ex') ?></li>
  <li><?php _e('SlimStat-Ex performance tool', 'wp-slimstat-ex') ?></li>
  <li><?php _e('Update ip-to-country database', 'wp-slimstat-ex') ?></li>
  <li><?php _e('Upgrade from Wp-SlimStat(0.92)', 'wp-slimstat-ex') ?></li>
  <li><?php _e('Upgrade from Wp-ShortStat', 'wp-slimstat-ex') ?></li>
  <li><?php _e('Display available modules', 'wp-slimstat-ex') ?></li>
  </ul>
  <legend style="font-size:1.3em;"><a href="<?php echo $this->admin_url; ?>/index.php"><?php _e('Go to SlimStat Admin Page', 'wp-slimstat-ex') ?> &raquo;</a></legend>
 	</fieldset>
 <hr />

	<fieldset class="options">
  <legend><?php _e('Re-build ip-to-country DB', 'wp-slimstat-ex') ?></legend>
	<form name="reimport_iptc" method="post" action="<?php echo $this->url; ?>&amp;wpssop=admin">
	<p style="padding:2px 20px;"><?php _e('Press "Re-build ip-to-country" button below to re-build IPTC DB.', 'wp-slimstat-ex'); ?></p>
	<p style="padding:2px 20px;"><?php _e('<strong>NOTE</strong>: It may takes time to importing. Please be patient until the full page is loaded and "success" message appears.', 'wp-slimstat-ex'); ?></p>
	<p class="submit">
	<input type="submit" name="do_reimport" value="<?php _e('Re-build ip-to-country DB', 'wp-slimstat-ex'); ?> &raquo;" />
	</p>
	</form>
	</fieldset>
	<hr />

	<fieldset class="options">
 <legend><?php _e('SlimStat-Ex external tracking', 'wp-slimstat-ex') ?></legend>
  <ul>
<?php if ($SlimCfg->is_wpmu) { ?>
	<li><?php _e('External tracking does not support Wordpress-MU by now.', 'wp-slimstat-ex') ?></li>
<?php } else { ?>
	<li><?php _e('If you want to track external PHP web tools on your server, rename <strong>external-sample.php</strong> to <strong>external.php</strong> and change some values refer to code below', 'wp-slimstat-ex'); ?><br />
  <div style="padding:8px;margin:6px 0px;border:1px solid gray;background-color:#f8f8f8;color:#14568A;">
	// ** MySQL settings ** //<br />
	<code>$slimtrack_ext['DB_NAME']</code> = '<?php echo DB_NAME; ?>';&nbsp;&nbsp;&nbsp;&nbsp;// The name of the database<br />
	<code>$slimtrack_ext['DB_USER']</code> = '<?php echo DB_USER; ?>';&nbsp;&nbsp;&nbsp;&nbsp;// Your MySQL username<br />
	<code>$slimtrack_ext['DB_PASSWORD']</code> = '<?php echo DB_PASSWORD; ?>';&nbsp;&nbsp;// ...and password<br />
	<code>$slimtrack_ext['DB_HOST']</code> = '<?php echo DB_HOST; ?>';&nbsp;&nbsp;&nbsp;// 99% chance you won't need to change this value<br />
	<?php if($SlimCfg->wp_version() > '2.1') { ?>
	<code>if(!defined('DB_CHARSET')) define('DB_CHARSET', '<?php echo DB_CHARSET; ?>');</code><br />
	<code>if(!defined('DB_COLLATE')) define('DB_COLLATE', '<?php echo DB_COLLATE; ?>');</code><br />
	<?php } ?>
	<br />
	// You can have multiple installations in one database if you give each a unique prefix<br />
	<code>$slimtrack_ext['table_prefix']</code>  = '<?php echo $table_prefix; ?>';&nbsp;&nbsp;// Only numbers, letters, and underscores please!<br />
	</div></li>
  <li><?php _e('Put the line of code below on any page you want to track.', 'wp-slimstat-ex'); ?><br />
  <div style="padding:8px;margin:6px 0px;border:1px solid gray;background-color:#f8f8f8;color:#14568A;">&lt;?php include_once("<?php echo $_SERVER['DOCUMENT_ROOT'].'/'.$SlimCfg->_getWebPath('siteurl'); ?>/wp-content/plugins/<?php echo $SlimCfg->basedir; ?>/lib/external.php"); ?&gt;</div></li>
<?php } ?>
  </ul>
 	</fieldset>
<?php
	}

	function &get_instance() {
		static $instance = array();
		if ( empty( $instance ) ) {
			$instance[] =& new wp_slimstat_ex_options();
		}
		return $instance[0];
	}

}

?>