<?php
/*
Plugin Name: WP-SlimStat-Ex
Plugin URI: http://082net.com/tag/wp-slimstat-ex/
Description: Track your blog stats. Based on <a href="http://www.duechiacchiere.it/">Mr. Coolmann</a>'s <a href="http://www.duechiacchiere.it/wp-slimstat/">Wp-SlimStat</a>. 
Version: 1.606
Author: Cheon, Young-Min
Author URI: http://082net.com/
*/

/*
ABOUT MODIFICATION ::
	Almost php and sql codes has written by Mr. Coolmann(http://www.duechiacchiere.it)
	What I've done is intergrating Ajax, constructing Pins(plugable panel) condition and some little patches.
	Thanks, Coolmann.

License ::
/*
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

http://www.gnu.org/licenses/gpl.txt

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
______________________________________________________________*/

/*
Authors(others) ::
MooTools(and moo.fx) :: http://mootools.net by Mad4Milk (http://mad4milk.net/).
icons :: Mark James(http://www.famfamfam.com/)
Ajax.History :: Siegfried Puchbauer <rails-spinoffs@lists.rubyonrails.org>
SweetTitles :: Dustin Diaz (http://www.dustindiaz.com)
IP-Lookup is powered by http://ip-lookup.net/
*/

// Protect the script from direct access
if ( !defined('ABSPATH') ) {
	header("Location: /");
	exit();
}

if(!function_exists('is_admin')) : // is_admin() included since v1.5.1
function is_admin(){
	return (strstr($_SERVER['PHP_SELF'], 'wp-admin/') || strstr($_SERVER['REQUEST_URI'], 'wp-admin/'));
}
endif;

define('SLIMSTATPATH',  realpath( dirname( __FILE__ ) ) . '/');
define('wp_slimstat_ex',  'wp_slimstat_ex'); // for old Pins

// include SlimStat config file
include(SLIMSTATPATH . 'wp-slimstat-ex-config.php');

// Always includes streams.php and gettext.php
if ( $SlimCfg->wp_version() < '2.1' && !defined('WPCTPATH') && !class_exists('gettext_reader') ) {
	include_once(ABSPATH . WPINC . '/streams.php');
	include_once(ABSPATH . WPINC . '/gettext.php');
}

// localize plugin
load_plugin_textdomain('wp-slimstat-ex', 'wp-content/plugins/'.$SlimCfg->basedir.'/lang');

class wp_slimstat_ex {

	function admin_head() {
		global $SlimCfg;
		if(wp_slimstat_ex::is_slimstat_page()) {
			$load_css = '<link rel="stylesheet" type="text/css" media="screen" href="'.$SlimCfg->pluginURL.'/css/slimstat.css?ver='.$SlimCfg->version.'" />';
			$load_css .= ($SlimCfg->option['nice_titles'])?"\n".'<link rel="stylesheet" type="text/css" media="screen" href="'.$SlimCfg->pluginURL.'/css/sweetTitles.css?ver='.$SlimCfg->version.'" />':'';
			echo "\n".'<!-- Added by Wp-SlimStat-Ex '.$SlimCfg->version.' -->'."\n".$load_css."\n";
			if(!function_exists('wp_print_scripts'))
				wp_slimstat_ex::admin_js();
		}
	}

	function admin_js() {
		global $SlimCfg;
		$before = '<script type="text/javascript" src="'.$SlimCfg->pluginURL.'/js/';
		$after = '"></script>'."\n";
		$load_js = '';
		$load_js .= $before.'prototype.js?ver=1.6.0_rc0'.$after;
		$load_js .= $before.'moo.fx.base.js?ver=2.0'.$after;
		$load_js .= $before.'ajax.history.js?ver='.$SlimCfg->version.$after;
		$load_js .= $before.'ajax-slimstat-proto.js?ver='.$SlimCfg->version.$after;
		if($SlimCfg->option['nice_titles']) {
			$load_js .= $before.'addEvent.js?ver='.$SlimCfg->version.$after;
			$load_js .= $before.'sweetTitles?ver='.$SlimCfg->version.$after;
		}
		echo $load_js;
	}

	function enqueue_script_admin() {
		global $SlimCfg;
		$src_path = $SlimCfg->pluginURL.'/js/';
		$SlimCfg->base_jslib = 'prototype';
		switch($SlimCfg->base_jslib) {
			case 'jquery':
			wp_enqueue_script('ajax-slimstat-jquery', $src_path.'ajax-slimstat-jquery.js', array('jquery-form'), $SlimCfg->version);
			break;
			case 'prototype':
			wp_register_script('moo.fx.base', $src_path.'moo.fx.base.js', array('prototype'), '2.0');
			wp_register_script('ajax.history', $src_path.'ajax.history.js', array('prototype'), $SlimCfg->version);
			wp_enqueue_script('ajax-slimstat-proto', $src_path.'ajax-slimstat-proto.js', array('prototype', 'moo.fx.base','ajax.history'), $SlimCfg->version);
			break;
			case 'mootools':
			wp_register_script('mootools-Base', $src_path.'mootools/Base.js', false, '1.11');
			wp_register_script('mootools-Effects', $src_path.'mootools/Effects.js', array('mootools-Base'), '1.11');
			wp_register_script('mootools-Remote', $src_path.'mootools/Remote.js', array('mootools-Base'), '1.11');
			wp_register_script('mootools-Plugins-Remote', $src_path.'mootools/Plugins-Remote.js', array('mootools-Remote'), '1.11');
			wp_register_script('ajax.history.mootools', $src_path.'ajax.history.mootools.js', array('mootools-Base', 'mootools-Remote'), $SlimCfg->version);
			wp_enqueue_script('ajax-slimstat-proto', $src_path.'ajax-slimstat-moo.js', array('mootools-Base', 'mootools-Effects','mootools-Remote', 'mootools-Plugins-Remote', 'ajax.history.mootools'), $SlimCfg->version);
			break;
		}
		if($SlimCfg->option['nice_titles']) {
			wp_register_script('addEvent', $src_path.'addEvent.js', false, $SlimCfg->version);
			wp_enqueue_script('sweetTitles', $src_path.'sweetTitles.js', array('addEvent'), $SlimCfg->version);
		}
	}

	function admin_footer() {
		global $SlimCfg;
?>
<script type="text/javascript">//<![CDATA[
var current_hash_string = window.location.href.split('#');
// use Ajax.History for ajax history

var historyHandler = Ajax.History.initialize({
				callback: function(hash){SlimStat.ajax(hash);},
				iframeSrc: "<?php echo $SlimCfg->pluginURL; ?>/js/_blank.html"
			});

if(current_hash_string[1] && current_hash_string[1] != '')
	var SlimStatLoader = SlimStat.ajax(current_hash_string[1]);
else 
	var SlimStatLoader = SlimStat.panel('1');
//]]></script>
<?php
	}

	function admin_notice() {
		global $SlimCfg;
		$ver = $SlimCfg->wp_version();
		if($ver < '2.0.2') {
			add_action('admin_footer', array('wp_slimstat_ex', '__notice'));
		} else {
			add_action('admin_notices', array('wp_slimstat_ex', '_notice'));
		}
	}

	function _notice() {
		global $SlimCfg;
		$slimstat_admin_url = get_option('siteurl') . '/wp-content/plugins/' . $SlimCfg->basedir . '/lib/ss-admin/upgrade.php';
		echo "<div id='wpssex_notice' class='updated fade'><p>".sprintf(__('WP-SlimStat-Ex needs <a href=\'%s\'>upgrade</a>', 'wp-slimstat-ex'), $slimstat_admin_url)."</p></div>";
	}

	function __notice() {
		global $SlimCfg;
		$slimstat_admin_url = get_option('siteurl') . '/wp-content/plugins/' . $SlimCfg->basedir . '/lib/ss-admin/upgrade.php';
?>
<script type="text/javascript">//<![CDATA[
if(!div_wraper_082net) {
	var div_wrapers_082net = document.getElementsByTagName('DIV');
	if(div_wrapers_082net) {
		for(var i=0; i<div_wrapers_082net.length; i++) {
			if(/wrap/.exec(div_wrapers_082net[i].className)) {
				var div_wraper_082net = div_wrapers_082net[i];
				break;
			}
		}
	}
}
if(div_wraper_082net) {
	var wpssex_notice = document.createElement("DIV");
	wpssex_notice.innerHTML = "<p><?php printf(__('WP-SlimStat-Ex needs <a href=\'%s\'>upgrade</a>', 'wp-slimstat-ex'), $slimstat_admin_url); ?></p>";
	wpssex_notice.className = 'updated fade';
	wpssex_notice.id = 'wpssex_notice';
	div_wraper_082net.parentNode.insertBefore(wpssex_notice, div_wraper_082net);
	Fat.fade_element('wpssex_notice');
}
//]]></script>
<?php
	}

	function option_page() {
		if (function_exists('add_options_page')) {
			require_once(SLIMSTATPATH.'wp-slimstat-ex-options.php');
			$wp_slimstat_ex_options =& wp_slimstat_ex_options::get_instance();
			add_options_page("SlimStat", "SlimStat", 'manage_options', 'wp-slimstat-ex-options', array(&$wp_slimstat_ex_options, 'options_page'));
		}
	}

	function is_slimstat_page () {
		return ( (strstr($_SERVER['PHP_SELF'], 'wp-admin/') || strstr($_SERVER['REQUEST_URI'], 'wp-admin/')) 
			&& 'wp-slimstat-ex' == trim($_GET['page']) );
	}

	function set_options() {
		global $SlimCfg;
		// set options if not exists
		if(!get_option('wp_slimstat_ex')) {
			$options['tracking'] = 1;
			$options['usepins'] = 1;
			$options['cachelimit'] = 0;
			$options['guesstitle'] = 1;
			$options['dbmaxage'] = 0;
			$options['limitrows'] = 20;
			$options['iptohost'] = 0;
			$options['whois'] = 1;
			$options['meta'] = 0;
			$options['visit_type'] = 'uniques';
			$options['count_type'] = 'hits';
			$options['stats_type'] = 'all';
			$options['time_offset'] = 0;
			$options['use_ajax'] = 1;
			$options['nice_titles'] = 1;
			$options['ignore_bots'] = 0;
			$SlimCfg->option = $options;
			update_option('wp_slimstat_ex', $options);
		}
		// set exclude options
		if(!get_option('wp_slimstat_ex_exclude')) {
			$exclude['ignore_bots'] = 0;
			$exclude['ig_bots'] = 0;
			$exclude['ig_feeds'] = 0;
			$exclude['ig_validators'] = 0;
			$exclude['ig_tools'] = 0;
			$exclude['black_ua'] = '';
			$exclude['white_ua'] = '';
			$exclude['ignore_ip'] = '';
			$SlimCfg->exclude = $exclude;
			update_option('wp_slimstat_ex_exclude', $exclude);
		}
	}

	function setup() {
		require(SLIMSTATPATH . 'lib/setup.php');
		SSSetup::do_setup();
	}

	function check_current_version() {
		global $SlimCfg;
		// if first install ?
		if(strpos($_SERVER['PHP_SELF'], 'wp-admin/plugins.php') !== false && $_GET['action'] == 'activate' && $_GET['plugin'] == $SlimCfg->_basename(__FILE__) )
			return true;
		$current = get_option('wp_slimstat_ex_version');
		if(!$current || $current == '0.1') {
			require_once(SLIMSTATPATH . 'lib/ss-admin/_functions.php');
			if(!isset($ssAdmin))
				$ssAdmin =& SSAdmin::get_instance();
			$is_15 = $ssAdmin->maybe_add_column($SlimCfg->table_pins, 'type', '', true);
			if(!$is_15) {
				update_option('wp_slimstat_ex_version', '0.1');
				return false;
			}				
			$is_16 = isset($SlimCfg->indexkey['common']['dt']) && isset($SlimCfg->indexkey['common']['remote_ip']);
			if(!$is_16) {
				update_option('wp_slimstat_ex_version', '1.5');
				return false;
			}
			update_option('wp_slimstat_ex_version', '1.6');
		}
		$current = get_option('wp_slimstat_ex_version');
		if($current < $SlimCfg->last_db_update_version)
			return false;
		update_option('wp_slimstat_ex_version', $SlimCfg->version);
		return true;
	}

	function call_queried_object() {
		global $SlimCfg;
		global $wp_query, $wp_the_query;
		if( !is_single() && !is_page() && (function_exists('is_attachment') && !is_attachment()) )
			return;
		// Fix queried object bug, if there's no wp_title on header.php of current theme.
		if($SlimCfg->wp_version() < '2.0.6') {
			if (is_null($wp_query->queried_object_id))
				$wp_query->get_queried_object();
			return;
		}
		if (is_null($wp_the_query->queried_object_id))
			$wp_the_query->get_queried_object();
		return;
	}

}
// end of class wp_slimstat_ex

/* Check Options */
if(!$SlimCfg->option || !$SlimCfg->exclude) {
	wp_slimstat_ex::set_options();
}

/* Setup, Option Page, Load CSS & Javascripts
-------------------------------------------*/
// setup WP-SlimStat-Ex
if($SlimCfg->wp_version() < '2' && !defined('WPCTPATH')) {
	if( strstr($_SERVER['REQUEST_URI'], 'wp-admin/plugins.php') && isset($_GET['activate']) && $_GET['activate'] == 'true' )
		add_action('init', array('wp_slimstat_ex', 'setup'));
}
add_action('activate_'.$SlimCfg->_basename(__FILE__), array('wp_slimstat_ex', 'setup'));

// load css and js on admin panel
add_action('admin_head', array('wp_slimstat_ex', 'admin_head'), 20);

if (wp_slimstat_ex::is_slimstat_page() && $SlimCfg->option['use_ajax']) {
	add_action('admin_footer', array('wp_slimstat_ex', 'admin_footer'));
	add_action('wp_print_scripts', array('wp_slimstat_ex', 'enqueue_script_admin'));
}
// option page
add_action('admin_menu', array('wp_slimstat_ex', 'option_page'));

/* Upgrade from previous version */
if(!wp_slimstat_ex::check_current_version()) {
//if($SlimCfg->version > get_option('wp_slimstat_ex_version')) {
	$SlimCfg->option['tracking'] = 0;
	wp_slimstat_ex::admin_notice();
	return;
}

/* Include functions
-------------------------------------------*/
require_once(SLIMSTATPATH . 'lib/functions.php');
// include Pin functions
if ($SlimCfg->option['usepins']) {
	require(SLIMSTATPATH . 'lib/pins.php');
//	SSPins::_incPins(4);// include functionable pins
	$current_pins = SSPins::_getPins(1, 4);
	if(!empty($current_pins)) {
		foreach($current_pins as $current_pin) {
			$current_pin_file = SLIMSTATPATH . 'pins/'. $current_pin->name . '/pin.php';
			if('' != $current_pin->name && file_exists($current_pin_file))
				include_once($current_pin_file);
		}
	}
}

/* Stats Display
-------------------------------------------*/
if(strstr($_SERVER['PHP_SELF'], 'wp-admin/') || strstr($_SERVER['REQUEST_URI'], 'wp-admin/')) { // 1.5.x fix
	require_once(SLIMSTATPATH . 'lib/display.php');
	add_action('admin_menu', array('SSDisplay','add_tab'));
}

/* Call queried object (Fix for http://trac.wordpress.org/ticket/5121)
-------------------------------------------*/
add_action('wp_head', array('wp_slimstat_ex', 'call_queried_object'), 0);

/* Track visitors
-------------------------------------------*/
require_once(SLIMSTATPATH . 'lib/track.php');
add_action( 'shutdown', array( &$SSTrack, 'slimtrack' ) );

?>